#include <stdio.h>
#include <string.h>

#define BUFFERSIZE 0x1000000

unsigned char g_u8aBuffer[BUFFERSIZE];

static void usageprint(void) {
	printf("MPO <-> JPEG converter by AZO\n");
	printf("Usage1(split): mpojcnv <MPO file>\n");
	printf("Usage2(merge): mpojcnv <JPEG file1> <JPEG file2>[ <JPEG file3>[ ...]]\n");
}

static int mposplit(const char* i_strMPO) {
	FILE* fpMPO;
	FILE* fpJPG;
	char strMPOName[1024];
	char strJPGName[1024];
	int iJPGNum = 0;
	size_t sizRes;
	char bFirst = 1;
	int iType = 0;
	size_t sizReadLen;

	fpMPO = fopen(i_strMPO, "rb");
	if(!fpMPO) {
		printf("Error: MPO file couldn't read open.\n");
		return -1;
	}

	strcpy(strMPOName, i_strMPO);
	strMPOName[strlen(strMPOName) - 4] = '\0';
	sprintf(strJPGName, "%s_%d.jpg", strMPOName, iJPGNum);
	fpJPG = fopen(strJPGName, "wb");
	if(!fpJPG) {
		fclose(fpMPO);
		printf("Error: JPEG file couldn't write open.\n");
		return -2;
	}

	while(sizReadLen = fread(g_u8aBuffer, 1, BUFFERSIZE, fpMPO)) {
		size_t i;
		size_t sizStart = 0;

		for(i = 0; i < sizReadLen; i++) {
			char bHit = 0;

			if(bFirst == 1 && i == 0) {
				if(
					g_u8aBuffer[i    ] == 0xFF &&
					g_u8aBuffer[i + 1] == 0xD8 &&
					g_u8aBuffer[i + 2] == 0xFF &&
					g_u8aBuffer[i + 3] == 0xE1
				) {
					iType = 1;
				} else if(
					g_u8aBuffer[i    ] == 0xFF &&
					g_u8aBuffer[i + 1] == 0xD8 &&
					g_u8aBuffer[i + 2] == 0xFF &&
					g_u8aBuffer[i + 3] == 0xE0
				) {
					iType = 2;
				} else if(
					g_u8aBuffer[i    ] == 0xFF &&
					g_u8aBuffer[i + 1] == 0xD8 &&
					g_u8aBuffer[i + 2] == 0xFF &&
					g_u8aBuffer[i + 3] == 0xDB
				) {
					iType = 3;
				}
				if(!iType) {
					printf("Error: MPO file is invalidate.\n");
					return -3;
				}
			}

			switch(iType) {
			case 1:
				if(
					g_u8aBuffer[i    ] == 0xFF &&
					g_u8aBuffer[i + 1] == 0xD8 &&
					g_u8aBuffer[i + 2] == 0xFF &&
					g_u8aBuffer[i + 3] == 0xE1
				) {
					bHit = 1;
				}
				break;
			case 2:
				if(
					g_u8aBuffer[i    ] == 0xFF &&
					g_u8aBuffer[i + 1] == 0xD8 &&
					g_u8aBuffer[i + 2] == 0xFF &&
					g_u8aBuffer[i + 3] == 0xE0
				) {
					bHit = 1;
				}
				break;
			case 3:
				if(
					g_u8aBuffer[i    ] == 0xFF &&
					g_u8aBuffer[i + 1] == 0xD8 &&
					g_u8aBuffer[i + 2] == 0xFF &&
					g_u8aBuffer[i + 3] == 0xDB
				) {
					bHit = 1;
				}
				break;
			}
			if(bFirst == 0 && bHit) {
				sizRes = fwrite(&(g_u8aBuffer[sizStart]), 1, i - sizStart, fpJPG);
				if(!sizRes) {
					fclose(fpMPO);
					fclose(fpJPG);
					printf("Error: JPEG file couldn't write.\n");
					return -4;
				}
				fclose(fpJPG);
				iJPGNum++;
				sizStart = i;

				sprintf(strJPGName, "%s_%d.jpg", strMPOName, iJPGNum);
				fpJPG = fopen(strJPGName, "wb");
				if(!fpJPG) {
					fclose(fpMPO);
					printf("Error: JPEG file couldn't write open.\n");
					return -2;
				}
			}
			bFirst = 0;
		}

		sizRes = fwrite(&(g_u8aBuffer[sizStart]), 1, sizReadLen - sizStart, fpJPG);
		if(!sizRes) {
			fclose(fpMPO);
			fclose(fpJPG);
			printf("Error: JPEG file couldn't write.\n");
			return -4;
		}
	}

	fclose(fpJPG);

	return 0;	
}

static int mpomerge(const int i_iArgc, const char* i_straArgv[]) {
	FILE* fpMPO;
	FILE* fpJPG;
	char strMPOName[1024];
	size_t sizRes;
	size_t sizReadLen;
	size_t sizLen;
	int i;
	size_t bFirst = 1;
	size_t bFileTop;
	int iType = 0;

	strcpy(strMPOName, i_straArgv[1]);
	sizLen = strlen(strMPOName);
	if(strMPOName[sizLen - 4] == '.') {
		strMPOName[sizLen - 4] = '\0';
	} else if(strMPOName[sizLen - 5] == '.') {
		strMPOName[sizLen - 5] = '\0';
	}
	strcat(strMPOName, ".mpo");
	fpMPO = fopen(strMPOName, "wb");
	if(!fpMPO) {
		printf("Error: MPO file couldn't write open.\n");
		return -1;
	}

	for(i = 1; i < i_iArgc; i++) {
		fpJPG = fopen(i_straArgv[i], "rb");
		if(!fpJPG) {
			fclose(fpMPO);
			printf("Error: MPO file couldn't read open.\n");
			return -2;
		}
		bFileTop = 1;

		while(sizReadLen = fread(g_u8aBuffer, 1, BUFFERSIZE, fpJPG)) {
			if(bFirst == 1) {
				if(
					g_u8aBuffer[0] == 0xFF &&
					g_u8aBuffer[1] == 0xD8 &&
					g_u8aBuffer[2] == 0xFF &&
					g_u8aBuffer[3] == 0xE1
				) {
					iType = 1;
				} else if(
					g_u8aBuffer[0] == 0xFF &&
					g_u8aBuffer[1] == 0xD8 &&
					g_u8aBuffer[2] == 0xFF &&
					g_u8aBuffer[3] == 0xE0
				) {
					iType = 2;
				} else if(
					g_u8aBuffer[0] == 0xFF &&
					g_u8aBuffer[1] == 0xD8 &&
					g_u8aBuffer[2] == 0xFF &&
					g_u8aBuffer[3] == 0xDB
				) {
					iType = 3;
				}
				if(!iType) {
					fclose(fpJPG);
					fclose(fpMPO);
					printf("Error: JPEG file is invalidate.\n");
					return -3;
				}
				bFirst = 0;
			}

			if(bFileTop) {
				switch(iType) {
				case 1:
					if(
						g_u8aBuffer[0] == 0xFF &&
						g_u8aBuffer[1] == 0xD8 &&
						g_u8aBuffer[2] == 0xFF &&
						g_u8aBuffer[3] == 0xE1
					) {
					} else {
						fclose(fpJPG);
						fclose(fpMPO);
						printf("Error: JPEG file is invalidate.\n");
						return -4;
					}
					break;
				case 2:
					if(
						g_u8aBuffer[0] == 0xFF &&
						g_u8aBuffer[1] == 0xD8 &&
						g_u8aBuffer[2] == 0xFF &&
						g_u8aBuffer[3] == 0xE0
					) {
					} else {
						fclose(fpJPG);
						fclose(fpMPO);
						printf("Error: JPEG file is invalidate.\n");
						return -4;
					}
					break;
				case 3:
					if(
						g_u8aBuffer[0] == 0xFF &&
						g_u8aBuffer[1] == 0xD8 &&
						g_u8aBuffer[2] == 0xFF &&
						g_u8aBuffer[3] == 0xDB
					) {
					} else {
						fclose(fpJPG);
						fclose(fpMPO);
						printf("Error: JPEG file is invalidate.\n");
						return -4;
					}
					break;
				}
				bFileTop = 0;
			}

			sizRes = fwrite(g_u8aBuffer, 1, sizReadLen, fpMPO);
			if(!sizRes) {
				fclose(fpMPO);
				fclose(fpJPG);
				printf("Error: MPO file couldn't write.\n");
				return -4;
			}
		}

		fclose(fpJPG);
	}

	fclose(fpMPO);

	return 0;
}

int main(const int i_iArgc, const char* i_straArgv[]) {
	int iFunction = 0;

	if(i_iArgc < 2) {
		usageprint();
		return 0;
	}

	if(i_iArgc == 2) {
		int iLen = strlen(i_straArgv[1]);
		if(iLen > 4) {
			if(
				(i_straArgv[1][iLen - 4] == '.') &&
				(i_straArgv[1][iLen - 3] == 'M' || i_straArgv[1][iLen - 3] == 'm') &&
				(i_straArgv[1][iLen - 2] == 'P' || i_straArgv[1][iLen - 2] == 'p') &&
				(i_straArgv[1][iLen - 1] == 'O' || i_straArgv[1][iLen - 1] == 'o')
			) {
				iFunction = 1;
			}
		}
	} else {
		int i;
		for(i = 1; i < i_iArgc - 1; i++) {
			size_t sizLen = strlen(i_straArgv[1]);
			if(sizLen > 5) {
				if(
					(
						(i_straArgv[i][sizLen - 4] == '.') &&
						(i_straArgv[i][sizLen - 3] == 'J' || i_straArgv[i][sizLen - 3] == 'j') &&
						(i_straArgv[i][sizLen - 2] == 'P' || i_straArgv[i][sizLen - 2] == 'p') &&
						(i_straArgv[i][sizLen - 1] == 'G' || i_straArgv[i][sizLen - 1] == 'g')
					) || (
						(i_straArgv[i][sizLen - 5] == '.') &&
						(i_straArgv[i][sizLen - 4] == 'J' || i_straArgv[i][sizLen - 4] == 'j') &&
						(i_straArgv[i][sizLen - 3] == 'P' || i_straArgv[i][sizLen - 3] == 'p') &&
						(i_straArgv[i][sizLen - 2] == 'E' || i_straArgv[i][sizLen - 2] == 'e') &&
						(i_straArgv[i][sizLen - 1] == 'G' || i_straArgv[i][sizLen - 1] == 'g')
					)
				) {
				} else {
					break;
				}
			} else {
				printf("Error: JPEG filename is invalidate.\n");
				return -1;
			}
		}
		if(i >= i_iArgc - 1) {
			iFunction = 2;
		}
	}

	switch(iFunction) {
	case 1:
		if(mposplit(i_straArgv[1]) < 0) {
			return -1;
		}
		break;
	case 2:
		if(mpomerge(i_iArgc, i_straArgv) < 0) {
			return -1;
		}
		break;
	default:
		printf("Error: Unknown.\n");
		return -1;
	}

	return 0;
}


